<script type="text/javascript">
    function expand_summary(e) {
        if (document.getElementById(`summary-graphs`).style.display == "none") {
            e.target.children[0].style.transform = 'rotate(0deg)';
            document.getElementById(`summary-graphs`).style.display = "block";
        } else {
            e.target.children[0].style.transform = 'rotate(-90deg)';
            document.getElementById(`summary-graphs`).style.display = "none";
        }
    }
</script>

<div class="title">
    <button class="expand" onclick="expand_summary(event)">
        <i class="fa-solid fa-lg fa-chevron-down" style="pointer-events: none;"></i>
    </button>
    <h2>General report</>
</div>



<div id="summary-graphs">
    <div style="flex: 1;">
        <figure class="highcharts-figure">
            <div id="cpu-compare-graph"></div>
        </figure>
    </div>
</div>


<!-- CPU COMPARISON GRAPH -->
<script type="text/javascript">

    let durations =  {{durations}};

    function quantile(sorted, q) {
        const pos = (sorted.length - 1) * q;
        const base = Math.floor(pos);
        const rest = pos - base;
        if (sorted[base + 1] !== undefined) {
            return sorted[base] + rest * (sorted[base + 1] - sorted[base]);
        } else {
            return sorted[base];
        }
    }

    let data = []
    for (let d of durations){
        data.push([Math.min(...d), quantile(d, .25), quantile(d, .5), quantile(d, .75), Math.max(...d)])
    }

    Highcharts.chart('cpu-compare-graph', {

        chart: {
            type: 'boxplot',
            zoomType: 'y',
        },

        title: {
            text: 'Hardware impact on duration'
        },

        legend: {
            enabled: false
        },

        xAxis: {
            categories: {{hardware_details}},
            title: {
                text: 'CPU, Memory'
            }
        },

        yAxis: {
            title: {
                text: 'Duration (s)'
            },
        },

        series: [{
            name: 'Durations',
            data: data,
            tooltip: {
                headerFormat: '{point.key}'
            }
        }], 
    });
</script>

